FUNCTION DDS_OpenTable(pcDDStable, pcTableKey, pcTableName, pcAlias, pcShared)

*	opens dbf in current workarea
*	not for multiuser environment


#DEFINE	mcERR01	[01 TableKey must not be empty]
#DEFINE	mcERR02	[02 TableName must not be empty]
#DEFINE	mcERR03	[03 DDStable not found: ]
#DEFINE	mcERR04	[11 DDStable empty: ]
#DEFINE	mcERR05	[12 Table definition not found: ]
#DEFINE	mcERR06	[21 Failed to open a table: ]
#DEFINE	mcERR07	[31 No field def found for: ]
#DEFINE	mcERR08	[99 Table not found: ]
#DEFINE	mcERR09	"41 The table changes cannot be performed: "
#DEFINE	mcERR10	"42 The index changes cannot be performed: "
		
private all like x*

*	pcDDStable	name of DDS table
*	pcTableKey	key of DBF-table definition in DDStable
*	pcTableName	filename of opened DBF-table
*	pcAlias			Alias of DBF-table, default pcTableKey
*	pcExclusive	[E]: exclusive	[S]: shared	[]: along SET EXCLUSIVE ..

*	returns:	[]	if succesfull
*						[errmsg] if failed

xcSel=Alias()
xcReturn=[]

***	adjustace parametru
xcDDStable=DefaultExt(Alltrim(pcDDStable), [dds])			&& DDStable name
xcTableKey=Upper(Alltrim(pcTableKey))									&& DDSkey
xcTableName=DefaultExt(Alltrim(pcTableName), [dbf])		&& DBFtable name
xcAlias=iif(empty(pcAlias), xcTableKey, Alltrim(pcAlias))	&& Alias
xcShared=iif(empty(pcShared), [], Upper(left(pcShared, 1)) )		&& shared/exclusive/nothing
xcShared=iif(xcShared==[E], [exclusive], iif(xcShared=[S], [shared], []) )


*****	Kontrola parametru a DDStabulky
IF empty(xcTableKey)
	xcReturn=xcReturn+mcERR01+chr(10)
ENDIF
IF empty(pcTableName)
	xcReturn=xcReturn+mcERR02+chr(10)
ENDIF
*		Kontrola, jestli DDS tabulka vubec existuje, jeji otevreni
IF .not.file(xcDDStable)		&& takova DDStabulka nenalezena
	xcReturn=xcReturn+mcERR03+xcDDStable+chr(10)
ELSE
	select 0
	use (xcDDStable) alias _DDS_DDS
	select * from (xcDDStable) order by DDSKEY asc, DDSTYP desc, DDSORDER asc into cursor DDS_Open1
	use in "_DDS_DDS"

	IF _TALLY = 0
		xcReturn=xcReturn+mcERR04+xcDDSTable+chr(10)
	ELSE
		select DDS_Open1
		locate for (Alltrim(DDSkey)==xcTableKey).and.(DDStyp==[T])
		IF .not.found()		&& takova definice tabulky v DDS vubec neexistuje
			xcReturn=xcReturn+mcERR05+xcTableKey+chr(10)
		ENDIF
	ENDIF
ENDIF

*****	Nejsou-li (DDStabulka a nebo parametry) O.K., zkusim otevrit (xcTableName) tak jak je bez kontrol
IF .not.empty(xcReturn)			&& vyskytly se chyby
	If Inlist(_CanIopenDbf(xcTableName, xcShared), 0, 1, 1707)			&& DBF jde otevrit, nebudou ale kontroly podle DDS
		if used("DDS_Open1")
			use in "DDS_Open1"
		endif
		select (iif(empty(xcSel), 0, (xcSel)) )		&& otevreni v puvodni workarea
		use (xcTableName) alias (xcAlias) &xcShared.			
		xcReturn=[]
	Else
		xcReturn=xcReturn+mcERR06+xcTableName+chr(10)	
	EndIf
	RETURN xcReturn
ENDIF

******************* dale jen, jsou-li DDS tabulka a parametry OK
***	DDS_Open1=kopie DDStabulky

xcOnError=On([ERROR])
ON ERROR do _myOnError1 with xcReturn, xcOnError, mcErr09+xcDDSfield+" - "
*****	kontrola definic poli
select 	DDSFNAME, DDSFTYP, DDSFLEN, DDSFDEC, DDSFNULL from DDS_Open1 		;
				where (Alltrim(DDSkey)==xcTableKey).and.(DDStyp==[F])			;
				into array xaDDSstructure
IF _TALLY = 0		&& nenasel zadne definice poli pro danou tabulku
		xcReturn=xcReturn+mcERR07+xcTableKey+chr(10)
ELSE
	IF .not.file(xcTableName)			&& DBF tabulka vubec neexistuje, zalozim ji
		select 0
		create table (xcTableName) from array xaDDSstructure
		use
	ELSE			&& kontrola a pripadna uprava struktury podle xaStructure
		IF Inlist(_CanIopenDbf(xcTableName, [Exclusive]), 0)
				select 0
				use (xcTableName) shared again
				xnDBFcount=AFields(xaDBFstructure)
				use
				* 1. kontrola poli v DBF neexistujicich nebo existujicich ale s odlisnou definici
				For xnI=1 to ALen(xaDDSstructure, 1)
						xcDDSfield=Upper(Alltrim(xaDDSstructure[xnI, 1]))
						xlFound=.F.
						xcTyp=xaDDSstructure[xnI, 2]
						IF xcTyp $ [B]		&& double musi mit DEC jako prvni parametr v ALTER
							xcLen=Transform(xaDDSstructure[xnI, 4])
							xcDec=[]
						ELSE
							xcLen=Transform(xaDDSstructure[xnI, 3])
							xcDec=Transform(xaDDSstructure[xnI, 4])
						ENDIF
						xcDec=iif(empty(xcDec), [], [, ]+xcDec)
						xcNull=iif(xaDDSstructure[xnI, 5], [NULL], [NOT NULL])
						for xnJ=1 to xnDBFcount
							if xcDDSfield==Upper(Alltrim(xaDBFstructure[xnJ, 1]))
								xlFound=.T.		&& pole tam je, ma stejnou definici?
								if .not.( (xaDDSstructure[xnI, 2]=xaDBFstructure[xnJ, 2]).and.		;
													(xaDDSstructure[xnI, 3]=xaDBFstructure[xnJ, 3]).and.		;
													(xaDDSstructure[xnI, 4]=xaDBFstructure[xnJ, 4]).and.		;
													(xaDDSstructure[xnI, 5]=xaDBFstructure[xnJ, 5]) )		&& nema, zmenim ho
									alter table (xcTableName) alter column &xcDDSfield. &xcTyp. ( &xcLen. &xcDec.) &xcNull.
									use
								endif
								exit
							endif
						endfor
						if .not.xlFound			&& takove pole tam vubec neni, zalozit ho
							alter table (xcTableName) add column &xcDDSfield. &xcTyp. ( &xcLen. &xcDec.) &xcNull.
							use
						endif
				EndFor				
				*	2. zruseni poli v DBF proti DDS nadbytecnych
				For xnI=1 to xnDBFcount
						xcDBFfield=Upper(Alltrim(xaDBFstructure[xnI, 1]))
						if AScan(xaDDSstructure, xcDBFfield)=0		&& v DDS tohle pole vubec neni, zrusit
							alter table (xcTableName) drop column &xcDBFfield. 						
							use
						endif
				EndFor
		ELSE		&& tabulku nelze otevrit EXCLUSIVE a tudiz ani menit jeji strukturu
*			xcReturn=xcReturn+[32 (Field check) DBFtable cannot be opened exclusively ]+xcTableName+chr(10)
		ENDIF  && _CanIopenDbf(xcTableName, [Exclusive])
	ENDIF			&& kontrola a pripadna uprava struktury podle xaStructure

ENDIF		&& nenasel zadne definice poli

*****	kontrola indexu

xcTagErr=""
ON ERROR do _myOnError1 with xcReturn, xcOnError, mcErr10+xcDDStag+[ - ]
IF Inlist(_CanIopenDbf(xcTableName, [Exclusive]), 0, 1707)
	select 	Upper(alltrim(DDSFNAME)), Alltrim(DDSTAG) from DDS_Open1 		;
					where (Alltrim(DDSkey)==xcTableKey).and.(DDStyp==[I])			;
					into array xaDDStags
	select 0
	use (xcTableName) alias DDS_Open2 exclusive	&& 110 File must be opened exclusively.
	IF _TALLY > 0		&& nejake indexy jsou definovany, zkontroluji je
				*	1. chybejici nebo jinak definovane
				For xnI=1 to ALen(xaDDStags, 1)
					xcDDStag=Alltrim(xaDDStags[xnI, 1])
					xcDDSkey=Alltrim(xaDDStags[xnI, 2])
*					xcTypeOfKey=Type(xcDDSkey)
*					if xcTypeOfKey=="U"
*						xcTagErr=xcTagErr+chr(10)+"wrong index expression: "+xcDDStag+"/"+xcDDSkey
*						loop
*					endif
					xlFound=.F.
					for xnJ=1 to 255
						xcTag=Upper(Tag(xnJ))
						If empty(xcTag)
							exit
						EndIf
						xcKey=Key(xnJ)
						xcFor=For(xnJ)
						xcKey=xcKey+iif(empty(xcFor), [], [ FOR ]+xcFor)
						if xcTag==xcDDStag			&& takovy tag nalezen, je shodny?
							xlFound=.T.
							if .not.(ChrTran(Upper(xcDDSkey), [ ], []) == ChrTran(Upper(xcKey), [ ], []))
								index on &xcDDSkey. tag &xcDDStag.
							endif
							exit
						endif
					endfor
						if .not.xlFound		&& takovy xcDDStag vubec neni, zalozit
						index on &xcDDSkey. tag &xcDDStag.
					endif
				EndFor
				* zruseni prebytecnych tagu
				For xnJ=1 to 255
					xcTag=Upper(Tag(xnJ))
					If empty(xcTag)
						exit
					EndIf
					xcKey=Key(xnJ)
					xcFor=For(xnJ)
					xcKey=xcKey+iif(empty(xcFor), [], [ FOR ]+xcFor)

					if AScan(xaDDStags, xcTag) = 0		&& takovy tag v DDS neni, zrusim ho
						delete tag &xcTag.
					endif
				Endfor
			
	ELSE		&& zadne indexy nejsou definovany, vsechny zrusit (pokud jsou)
				select DDS_Open2
				delete tag all			&& zadne v DDS nejsou, vsechny zrusim (pokud jsou)
	ENDIF		&& nejake indexy jsou definovany, zkontroluji je
	use in [DDS_Open2]

ELSE	&& _CanIopenDbf(xcTableName, [Exclusive])	
*			xcReturn=xcReturn+[33 (Index check) DBFtable cannot be opened exclusively ]+xcTableName+chr(10)
ENDIF		&& can use exclusive
IF .not.empty(xcTagErr)
	xcReturn=xcReturn+chr(10)+mcERR10+xcTagErr
ENDIF

*****	Konec

ON ERROR &xcOnError.
		
use in [DDS_Open1]
select (iif(empty(xcSel), 0, (xcSel)) )		&& otevreni v puvodni workarea
IF empty(xcReturn)		&& otevrit jen kdyz nebyly chyby
	If Inlist(_CanIopenDbf(xcTableName, xcShared), 0)			&& DBF jde otevrit
		use (xcTableName) alias (xcAlias) &xcShared. again
	Else
		xcReturn=xcReturn+mcERR06+xcTableName+chr(10)	
	EndIf
ENDIF


IF used(xcAlias)
	select (xcAlias)
ELSE
	select (iif(empty(xcSel), 0, (xcSel)) )
ENDIF
RETURN xcReturn

*****	CanIopenDbf upravena pro potreby teto funkce
*		dulezite chyby:
*			1531 The table changes cannot be performed as the index or filter expression for index XXX would be invalid.
*			1707	CDX not found
*			114		poskozeny CDX
*			12 Variable 'XXX' is not found.
*			112 Invalid key length.
*			1713 Field width or number of decimal places is invalid. 
*			1712 Field name is duplicated or invalid
*			107 Operator/operand type mismatch.

FUNCTION _CanIopenDbf(pcTableName, pcModus)	&& pcModus=[Exclusive] / [Shared] / []
*	pro neexistujici nebo poskozene CDX funkce automaticky zrusi odkaz na CDX v hlavicce DBF
private all like x*
xcSel=Alias()
xcOnError=On([ERROR])
select 0
ON ERROR store Error() to xnReturn
DO while .T.
	xnReturn=0
	use (pcTableName) &pcModus. again
	DO case
		case xnReturn=1707			&& CDX not found - opakovat USE
*			Logging("chyba 1707")
		case xnReturn=114				&& CDX damaged - opakovat USE
*			Logging("chyba 114")
			erase (ForceExt(pcTableName, "cdx"))
		otherwise
			exit
	ENDCASE
ENDDO
use
ON ERROR &xcOnError.
select (iif(empty(xcSel), 0, (xcSel)) )
RETURN xnReturn

FUNCTION _myOnError1(pcErrMsg, pcOnError, pcErrText)
private all like x*
xnErrNr=Error()
IF Inlist(xnErrNr, 1531, 12, 107, 112, 1713, 1712)			&& chyba
		pcErrMsg=pcErrMsg+pcErrText+" "+Transform(xnErrNr)+" "+message()+chr(10)
ELSE
		&pcOnError.
ENDIF
RETURN .T.